/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.15 Revision 1.27
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.15 2009/07/27 19:03:20 kolmodin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.27 2012/02/07 12:47:54 slyfox Exp $
4# 4
5# @ECLASS: haskell-cabal.eclass
6# @MAINTAINER:
7# Haskell herd <haskell@gentoo.org>
8# @AUTHOR:
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 9# Original author: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 10# Original author: Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 11# @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
8# 12# @DESCRIPTION:
9# This eclass is for packages that make use of the
10# Haskell Common Architecture for Building Applications
11# and Libraries (cabal).
12#
13# Basic instructions: 13# Basic instructions:
14# 14#
15# Before inheriting the eclass, set CABAL_FEATURES to 15# Before inheriting the eclass, set CABAL_FEATURES to
16# reflect the tools and features that the package makes 16# reflect the tools and features that the package makes
17# use of. 17# use of.
18# 18#
19# Currently supported features: 19# Currently supported features:
20# haddock -- for documentation generation 20# haddock -- for documentation generation
21# hscolour -- generation of colourised sources
21# alex -- lexer/scanner generator 22# alex -- lexer/scanner generator
22# happy -- parser generator 23# happy -- parser generator
23# c2hs -- C interface generator 24# c2hs -- C interface generator
24# cpphs -- C preprocessor clone written in Haskell 25# cpphs -- C preprocessor clone written in Haskell
25# profile -- if package supports to build profiling-enabled libraries 26# profile -- if package supports to build profiling-enabled libraries
26# bootstrap -- only used for the cabal package itself 27# bootstrap -- only used for the cabal package itself
27# bin -- the package installs binaries 28# bin -- the package installs binaries
28# lib -- the package installs libraries 29# lib -- the package installs libraries
30# nocabaldep -- don't add dependency on cabal.
31# only used for packages that _must_ not pull the dependency
32# on cabal, but still use this eclass (e.g. haskell-updater).
29# 33#
30# Dependencies on other cabal packages have to be specified 34# Dependencies on other cabal packages have to be specified
31# correctly. 35# correctly.
32# 36#
33# Cabal libraries should usually be SLOTted with "${PV}". 37# Cabal libraries should usually be SLOTted with "${PV}".
40# Special flags to Cabal Configure can now be set by using 44# Special flags to Cabal Configure can now be set by using
41# CABAL_CONFIGURE_FLAGS 45# CABAL_CONFIGURE_FLAGS
42 46
43inherit ghc-package multilib 47inherit ghc-package multilib
44 48
49# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
50# @DESCRIPTION:
51# User-specified additional parameters passed to 'setup configure'.
52# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
53: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
54
55# @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
56# @DESCRIPTION:
57# User-specified additional parameters passed to 'setup build'.
58# example: /etc/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
59: ${CABAL_EXTRA_BUILD_FLAGS:=}
60
61# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
62# @DESCRIPTION:
63# User-specified additional parameters for ghc when building
64# _only_ 'setup' binary bootstrap.
65# example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
66# linking 'setup' faster.
67: ${GHC_BOOTSTRAP_FLAGS:=}
68
69HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
70
71case "${EAPI:-0}" in
72 2|3|4) HASKELL_CABAL_EXPF+=" src_configure" ;;
73 *) ;;
74esac
75
76EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
45 77
46for feature in ${CABAL_FEATURES}; do 78for feature in ${CABAL_FEATURES}; do
47 case ${feature} in 79 case ${feature} in
48 haddock) CABAL_USE_HADDOCK=yes;; 80 haddock) CABAL_USE_HADDOCK=yes;;
81 hscolour) CABAL_USE_HSCOLOUR=yes;;
82 hoogle) CABAL_USE_HOOGLE=yes;;
49 alex) CABAL_USE_ALEX=yes;; 83 alex) CABAL_USE_ALEX=yes;;
50 happy) CABAL_USE_HAPPY=yes;; 84 happy) CABAL_USE_HAPPY=yes;;
51 c2hs) CABAL_USE_C2HS=yes;; 85 c2hs) CABAL_USE_C2HS=yes;;
52 cpphs) CABAL_USE_CPPHS=yes;; 86 cpphs) CABAL_USE_CPPHS=yes;;
53 profile) CABAL_USE_PROFILE=yes;; 87 profile) CABAL_USE_PROFILE=yes;;
54 bootstrap) CABAL_BOOTSTRAP=yes;; 88 bootstrap) CABAL_BOOTSTRAP=yes;;
55 bin) CABAL_HAS_BINARIES=yes;; 89 bin) CABAL_HAS_BINARIES=yes;;
56 lib) CABAL_HAS_LIBRARIES=yes;; 90 lib) CABAL_HAS_LIBRARIES=yes;;
91 nocabaldep) CABAL_FROM_GHC=yes;;
57 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";; 92 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
58 esac 93 esac
59done 94done
60 95
61if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 96if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
62 IUSE="${IUSE} doc" 97 IUSE="${IUSE} doc"
63 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 98 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
64fi 99fi
65 100
101if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
102 IUSE="${IUSE} hscolour"
103 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
104fi
105
66if [[ -n "${CABAL_USE_ALEX}" ]]; then 106if [[ -n "${CABAL_USE_ALEX}" ]]; then
67 DEPEND="${DEPEND} dev-haskell/alex" 107 DEPEND="${DEPEND} dev-haskell/alex"
68 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
69fi 108fi
70 109
71if [[ -n "${CABAL_USE_HAPPY}" ]]; then 110if [[ -n "${CABAL_USE_HAPPY}" ]]; then
72 DEPEND="${DEPEND} dev-haskell/happy" 111 DEPEND="${DEPEND} dev-haskell/happy"
73 cabalconf="${cabalconf} --with-happy=/usr/bin/happy"
74fi 112fi
75 113
76if [[ -n "${CABAL_USE_C2HS}" ]]; then 114if [[ -n "${CABAL_USE_C2HS}" ]]; then
77 DEPEND="${DEPEND} dev-haskell/c2hs" 115 DEPEND="${DEPEND} dev-haskell/c2hs"
78 cabalconf="${cabalconf} --with-c2hs=/usr/bin/c2hs"
79fi 116fi
80 117
81if [[ -n "${CABAL_USE_CPPHS}" ]]; then 118if [[ -n "${CABAL_USE_CPPHS}" ]]; then
82 DEPEND="${DEPEND} dev-haskell/cpphs" 119 DEPEND="${DEPEND} dev-haskell/cpphs"
83 cabalconf="${cabalconf} --with-cpphs=/usr/bin/cpphs"
84fi 120fi
85 121
86if [[ -n "${CABAL_USE_PROFILE}" ]]; then 122if [[ -n "${CABAL_USE_PROFILE}" ]]; then
87 IUSE="${IUSE} profile" 123 IUSE="${IUSE} profile"
88fi 124fi
90# We always use a standalone version of Cabal, rather than the one that comes 126# We always use a standalone version of Cabal, rather than the one that comes
91# with GHC. But of course we can't depend on cabal when building cabal itself. 127# with GHC. But of course we can't depend on cabal when building cabal itself.
92if [[ -z ${CABAL_MIN_VERSION} ]]; then 128if [[ -z ${CABAL_MIN_VERSION} ]]; then
93 CABAL_MIN_VERSION=1.1.4 129 CABAL_MIN_VERSION=1.1.4
94fi 130fi
95if [[ -z "${CABAL_BOOTSTRAP}" ]]; then 131if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
96 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}" 132 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
97fi 133fi
98 134
99# Libraries require GHC to be installed. 135# Libraries require GHC to be installed.
100if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then 136if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
107 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then 143 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
108 if [[ "${CABAL_BOOTSTRAP}" ]]; then 144 if [[ "${CABAL_BOOTSTRAP}" ]]; then
109 # We're bootstrapping cabal, so the cabal version is the version 145 # We're bootstrapping cabal, so the cabal version is the version
110 # of this package itself. 146 # of this package itself.
111 _CABAL_VERSION_CACHE="${PV}" 147 _CABAL_VERSION_CACHE="${PV}"
148 elif [[ "${CABAL_FROM_GHC}" ]]; then
149 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
150 # /path/to/ghc/Cabal-${VER} -> ${VER}
151 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
112 else 152 else
113 # We ask portage, not ghc, so that we only pick up 153 # We ask portage, not ghc, so that we only pick up
114 # portage-installed cabal versions. 154 # portage-installed cabal versions.
115 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)" 155 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
116 fi 156 fi
138 else 178 else
139 # older ghc's don't support package versioning 179 # older ghc's don't support package versioning
140 cabalpackage=Cabal 180 cabalpackage=Cabal
141 fi 181 fi
142 einfo "Using cabal-$(cabal-version)." 182 einfo "Using cabal-$(cabal-version)."
183
184 make_setup() {
143 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" -o setup \ 185 set -- -package "${cabalpackage}" --make "${setupmodule}" \
186 ${GHC_BOOTSTRAP_FLAGS} \
187 "$@" \
188 -o setup
189 echo $(ghc-getghc) ${HCFLAGS} "$@"
190 $(ghc-getghc) "$@"
191 }
192 if $(ghc-supports-shared-libraries); then
193 # some custom build systems might use external libraries,
194 # for which we don't have shared libs, so keep static fallback
195 make_setup -dynamic "$@" || make_setup "$@" || die "compiling ${setupmodule} failed"
196 else
144 || die "compiling ${setupmodule} failed" 197 make_setup "$@" || die "compiling ${setupmodule} failed"
198 fi
145} 199}
146 200
147cabal-mksetup() { 201cabal-mksetup() {
148 local setupdir 202 local setupdir
149 203
157 211
158 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \ 212 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
159 > $setupdir/Setup.hs 213 > $setupdir/Setup.hs
160} 214}
161 215
216cabal-hscolour() {
217 set -- hscolour "$@"
218 echo ./setup "$@"
219 ./setup "$@" || die "setup hscolour failed"
220}
221
162cabal-haddock() { 222cabal-haddock() {
163 ./setup haddock || die "setup haddock failed" 223 set -- haddock "$@"
224 echo ./setup "$@"
225 ./setup "$@" || die "setup haddock failed"
226}
227
228cabal-hscolour-haddock() {
229 # --hyperlink-source implies calling 'setup hscolour'
230 set -- haddock --hyperlink-source
231 echo ./setup "$@"
232 ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
164} 233}
165 234
166cabal-configure() { 235cabal-configure() {
236 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
237
167 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 238 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
168 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock" 239 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
169 fi 240 fi
170 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 241 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
171 cabalconf="${cabalconf} --enable-library-profiling" 242 cabalconf="${cabalconf} --enable-library-profiling"
172 fi 243 fi
244 if [[ -n "${CABAL_USE_ALEX}" ]]; then
245 cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
246 fi
247
248 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
249 cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
250 fi
251
252 if [[ -n "${CABAL_USE_C2HS}" ]]; then
253 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
254 fi
255 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
256 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
257 fi
258
259 local option
260 for option in ${HCFLAGS}
261 do
262 cabalconf+=" --ghc-option=$option"
263 done
264
173 # Building GHCi libs on ppc64 causes "TOC overflow". 265 # Building GHCi libs on ppc64 causes "TOC overflow".
174 if use ppc64; then 266 if use ppc64; then
175 cabalconf="${cabalconf} --disable-library-for-ghci" 267 cabalconf="${cabalconf} --disable-library-for-ghci"
176 fi 268 fi
177 269
270 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
271 # so translate LDFLAGS to ghc parameters (without filtering)
272 local flag
273 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
274
275 if version_is_at_least "1.4" "$(cabal-version)"; then
276 # disable executable stripping for the executables, as portage will
277 # strip by itself, and pre-stripping gives a QA warning.
278 # cabal versions previous to 1.4 does not strip executables, and does
279 # not accept the flag.
280 # this fixes numerous bugs, amongst them;
281 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
282 cabalconf="${cabalconf} --disable-executable-stripping"
283 fi
284
178 if version_is_at_least "1.2.0" "$(cabal-version)"; then 285 if version_is_at_least "1.2.0" "$(cabal-version)"; then
179 cabalconf="${cabalconf} --docdir=/usr/share/doc/${PF}" 286 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
180 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes 287 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
181 # it's better if the configure chatter is in the build logs: 288 # it's better if the configure chatter is in the build logs:
182 cabalconf="${cabalconf} --verbose" 289 cabalconf="${cabalconf} --verbose"
183 fi 290 fi
184 # Note: with Cabal-1.1.6.x we do not have enough control 291 # Note: with Cabal-1.1.6.x we do not have enough control
185 # to put the docs into the right place. They're currently going 292 # to put the docs into the right place. They're currently going
186 # into /usr/share/${P}/ghc-x.y/doc/ 293 # into /usr/share/${P}/ghc-x.y/doc/
187 # rather than /usr/share/doc/${PF}/ 294 # rather than /usr/share/doc/${PF}/
188 # Because we can only set the datadir, not the docdir. 295 # Because we can only set the datadir, not the docdir.
189 296
297 # We build shared version of our Cabal where ghc ships it's shared
298 # version of it. We will link ./setup as dynamic binary againt Cabal later.
299 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
300 $(ghc-supports-shared-libraries) && \
301 cabalconf="${cabalconf} --enable-shared"
302
190 ./setup configure \ 303 set -- configure \
191 --ghc --prefix=/usr \ 304 --ghc --prefix="${EPREFIX}"/usr \
192 --with-compiler="$(ghc-getghc)" \ 305 --with-compiler="$(ghc-getghc)" \
193 --with-hc-pkg="$(ghc-getghcpkg)" \ 306 --with-hc-pkg="$(ghc-getghcpkg)" \
194 --prefix=/usr \ 307 --prefix="${EPREFIX}"/usr \
195 --libdir=/usr/$(get_libdir) \ 308 --libdir="${EPREFIX}"/usr/$(get_libdir) \
196 --libsubdir=${P}/ghc-$(ghc-version) \ 309 --libsubdir=${P}/ghc-$(ghc-version) \
197 --datadir=/usr/share/ \ 310 --datadir="${EPREFIX}"/usr/share/ \
198 --datasubdir=${P}/ghc-$(ghc-version) \ 311 --datasubdir=${P}/ghc-$(ghc-version) \
199 ${cabalconf} \ 312 ${cabalconf} \
200 ${CABAL_CONFIGURE_FLAGS} \ 313 ${CABAL_CONFIGURE_FLAGS} \
314 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
315 "$@"
316 echo ./setup "$@"
201 "$@" || die "setup configure failed" 317 ./setup "$@" || die "setup configure failed"
202} 318}
203 319
204cabal-build() { 320cabal-build() {
205 unset LANG LC_ALL LC_MESSAGES 321 unset LANG LC_ALL LC_MESSAGES
206 ./setup build \ 322 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
323 echo ./setup "$@"
324 ./setup "$@" \
207 || die "setup build failed" 325 || die "setup build failed"
208} 326}
209 327
210cabal-copy() { 328cabal-copy() {
211 ./setup copy \ 329 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
212 --destdir="${D}" \ 330
331 set -- copy --destdir="${D}" "$@"
332 echo ./setup "$@"
213 || die "setup copy failed" 333 ./setup "$@" || die "setup copy failed"
214 334
215 # cabal is a bit eager about creating dirs, 335 # cabal is a bit eager about creating dirs,
216 # so remove them if they are empty 336 # so remove them if they are empty
217 rmdir "${D}/usr/bin" 2> /dev/null 337 rmdir "${ED}/usr/bin" 2> /dev/null
218 338
219 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has 339 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
220 # no workaround. 340 # no workaround.
221 # set the +x permission on executables 341 # set the +x permission on executables
222 if [[ -d "${D}/usr/bin" ]] ; then 342 if [[ -d "${ED}/usr/bin" ]] ; then
223 chmod +x "${D}/usr/bin/"* 343 chmod +x "${ED}/usr/bin/"*
224 fi 344 fi
225 # TODO: do we still need this? 345 # TODO: do we still need this?
226} 346}
227 347
228cabal-pkg() { 348cabal-pkg() {
271 391
272# exported function: check if cabal is correctly installed for 392# exported function: check if cabal is correctly installed for
273# the currently active ghc (we cannot guarantee this with portage) 393# the currently active ghc (we cannot guarantee this with portage)
274haskell-cabal_pkg_setup() { 394haskell-cabal_pkg_setup() {
275 ghc-package_pkg_setup 395 ghc-package_pkg_setup
276 if [[ -z "${CABAL_BOOTSTRAP}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then 396 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
277 eerror "The package dev-haskell/cabal is not correctly installed for" 397 eerror "The package dev-haskell/cabal is not correctly installed for"
278 eerror "the currently active version of ghc ($(ghc-version)). Please" 398 eerror "the currently active version of ghc ($(ghc-version)). Please"
279 eerror "run ghc-updater or re-emerge dev-haskell/cabal." 399 eerror "run ghc-updater or haskell-updater or re-build dev-haskell/cabal."
280 die "cabal is not correctly installed" 400 die "cabal is not correctly installed"
281 fi 401 fi
282 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then 402 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
283 eerror "QA: Neither bin nor lib are in CABAL_FEATURES." 403 eerror "QA: Neither bin nor lib are in CABAL_FEATURES."
284 fi 404 fi
288 if cabal-is-dummy-lib; then 408 if cabal-is-dummy-lib; then
289 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install." 409 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
290 fi 410 fi
291} 411}
292 412
413haskell-cabal_src_configure() {
414 if ! cabal-is-dummy-lib; then
415 pushd "${S}" > /dev/null
416
417 cabal-bootstrap
418
419 cabal-configure "$@"
420
421 popd > /dev/null
422 fi
423}
424
425# exported function: nice alias
426cabal_src_configure() {
427 haskell-cabal_src_configure "$@"
428}
429
293# exported function: cabal-style bootstrap configure and compile 430# exported function: cabal-style bootstrap configure and compile
294cabal_src_compile() { 431cabal_src_compile() {
432 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
433 # and forgets to separate src_compile() to src_configure()/src_compile().
434 # Such error leads to default src_configure and we lose all passed flags.
435 if ! has "${EAPI:-0}" 0 1; then
436 local passed_flag
437 for passed_flag in "$@"; do
438 [[ ${passed_flag} == --flags=* ]] && \
439 eqawarn "Cabal option '${passed_flag}' has effect only in src_configure()"
440 done
441 fi
442
295 if ! cabal-is-dummy-lib; then 443 if ! cabal-is-dummy-lib; then
296 cabal-bootstrap 444 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
297 cabal-configure
298 cabal-build 445 cabal-build
299 446
300 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 447 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
448 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
449 # hscolour and haddock
450 cabal-hscolour-haddock
451 else
452 # just haddock
301 cabal-haddock 453 cabal-haddock
454 fi
455 else
456 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
457 # just hscolour
458 cabal-hscolour
459 fi
302 fi 460 fi
303 fi 461 fi
304} 462}
463
305haskell-cabal_src_compile() { 464haskell-cabal_src_compile() {
465 pushd "${S}" > /dev/null
466
306 cabal_src_compile 467 cabal_src_compile "$@"
468
469 popd > /dev/null
470}
471
472haskell-cabal_src_test() {
473 pushd "${S}" > /dev/null
474
475 if cabal-is-dummy-lib; then
476 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
477 else
478 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
479 set -- test "$@"
480 echo ./setup "$@"
481 ./setup "$@" || die "cabal test failed"
482 fi
483
484 popd > /dev/null
307} 485}
308 486
309# exported function: cabal-style copy and register 487# exported function: cabal-style copy and register
310cabal_src_install() { 488cabal_src_install() {
489 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
490
311 if cabal-is-dummy-lib; then 491 if cabal-is-dummy-lib; then
312 # create a dummy local package conf file for the sake of ghc-updater 492 # create a dummy local package conf file for the sake of ghc-updater
313 dodir "$(ghc-confdir)" 493 local ghc_confdir_with_prefix="$(ghc-confdir)"
494 # remove EPREFIX
495 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
314 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)" 496 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
315 else 497 else
316 cabal-copy 498 cabal-copy
317 cabal-pkg 499 cabal-pkg
318 500
321 dohtml -r dist/doc/html/* 503 dohtml -r dist/doc/html/*
322 fi 504 fi
323 fi 505 fi
324 fi 506 fi
325} 507}
508
326haskell-cabal_src_install() { 509haskell-cabal_src_install() {
510 pushd "${S}" > /dev/null
511
327 cabal_src_install 512 cabal_src_install
328}
329 513
330EXPORT_FUNCTIONS pkg_setup src_compile src_install 514 popd > /dev/null
515}
516
517# ebuild.sh:use_enable() taken as base
518#
519# Usage examples:
520#
521# CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
522# leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
523#
524# CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
525# also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
526#
527cabal_flag() {
528 if [[ -z "$1" ]]; then
529 echo "!!! cabal_flag() called without a parameter." >&2
530 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
531 return 1
532 fi
533
534 local UWORD=${2:-$1}
535
536 if use "$1"; then
537 echo "--flags=${UWORD}"
538 else
539 echo "--flags=-${UWORD}"
540 fi
541
542 return 0
543}

Legend:
Removed from v.1.15  
changed lines
  Added in v.1.27

  ViewVC Help
Powered by ViewVC 1.1.20